package ch.phoenixtechnologies.quarkus.commons.clock;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import io.quarkus.test.InjectMock;
import io.quarkus.test.junit.QuarkusTest;
import jakarta.inject.Inject;
import java.time.Clock;
import java.time.Instant;
import org.junit.jupiter.api.Test;

@QuarkusTest
class ClockServiceImplTest {

    @Inject
    ClockService clockService;

    @InjectMock
    Clock clock;

    @Test
    void instant() {
        var expected = Instant.ofEpochMilli(1729280640915L);
        when(clock.instant()).thenReturn(expected);

        assertThat(clockService.instant())
                .as("Instant should match expected value")
                .isEqualTo(expected);
    }

    @Test
    void currentTimeMillis() {
        var expected = 1729280640915L;
        when(clock.millis()).thenReturn(expected);

        assertThat(clockService.currentTimeMillis())
                .as("Instant should match expected value")
                .isEqualTo(expected);
    }
}
